#ifndef _G_ENEMY_MANAGER_
#define _G_ENEMY_MANAGER_

#include <hpllib/cycle/HPLObjectManager.h>

//#include "GEnemy.h"
#include "GPlayer.h"


class GEnemyManager : public HPLObjectManager<GPlayer> {
private:
	std::list<GPlayer*> m_vecAdds;


public:
	GEnemyManager(){}
	virtual ~GEnemyManager(){}
	void process(bool isMove, bool bIsAI);
	/** 
	  * @param[in]		t			タイプ
	  * @param[in]		center		中心座標
	  * @param[in]		nForceID	生成者の所属軍
	  */
	GPlayer* create(int t, HPLVector center,
		int nForceID);

	void algorithm(GPlayer* enemy);
	bool checkHitToShot(GPlayer* enemy);

	/**	
		体当たりはプレイヤーに対してのみとする！
	*/
	bool checkHitToPlayer(GPlayer* enemy, GPlayer* player);

	/**
		他の敵と接触するか判定
	*/
	bool checkHitToEnemy(GPlayer* enemy);

};
#endif
